//playerMotion vars
private var playerModel: GameObject;
var speed: float = 7;
var rotateSpeed : float = 2.0;

private var armRun : AnimationState;

//playerShooting vars
var bubblePrefab: Transform;
var firePrefab: Transform;
var rocketPrefab: Transform;
var waterPrefab: Transform;
var pewPrefab: Transform;
var disintPrefab: Transform;
var rockPrefab: Transform;
var slingPrefab: Transform;
var spreadPrefab: Transform;
var vuvuPrefab: Transform;
var spgPrefab: Transform;
var spcPrefab: Transform;
var fireRate = 0.25;
private var nextFire = 0.0;
static var rockMultiplier = 1.0;


//hat Vars
private var fireRateMult = 1.0;
private var speedMult = 1.0;
private var injureBuffer = 0;
static var powerMult = 1.0;
var pylonPrefab: Transform;
var vikingPrefab: Transform;
var footballPrefab: Transform;
var cowboyPrefab: Transform;
var popePrefab: Transform;
var squidPrefab: Transform;
var tophatPrefab: Transform;
var slugPrefab: Transform;
private var hatDrop : Transform;

//for hat swapping
private var touchingHat = -1;
private var touchedHat;

//canister Vars
var capRedPrefab: Transform;
var capBluPrefab: Transform;
var capGrnPrefab: Transform;
var capPrpPrefab: Transform;
private var capDrop : Transform;
var capThrow: Transform;

var deathBubPF: Transform;
var healBubPF: Transform;

//for canister swapping
private var touchingCap = 0;
private var touchedCap;

//health Vars
var injureCounter = 800;
var injureRecover = 0.1;
static var gotHit = false;
static var gotHitBad = false;
var injurable = true;
private var backup = [injureCounter, injureRecover];
private var isDead = false;

//constraining orientation workaround
private var originalZ : float;
private var originalX : float;

//effects prefabs
var explosion : Transform;
var laserHit : Transform;
var fireHit : Transform;

//player stats
static var weapon = 3;
static var hat = -1;
static var cap = 0;
private var hasKey = false;

//for gun swapping
private var touchingGun = -1;
private var touchedGun;

//gun drop prefabs
var bubbleGun : Transform;
var flameGun : Transform;
var rocketGun : Transform;
var pewGun : Transform;
var spreadGun : Transform;
var rockGun : Transform;
var waterGun : Transform;
var disintGun : Transform;
var slingGun : Transform;
var vuvuGun : Transform;
var spGun : Transform;
var spcanGun : Transform;
private var gunDrop : Transform;


private var FlavTextTimer = 0.0;
private var FlavText2Timer = 0.0;

static var currentLevel = 1;

var switchSound: AudioClip;
var hurtSound: AudioClip;
var keySound: AudioClip;
var doorSound: AudioClip;


//initialize functions
function Awake(){
	originalZ = transform.eulerAngles.z;//for constraining rotation
	originalX = transform.eulerAngles.x;
	if (PlayerPrefs.GetInt("High Level")<currentLevel){
		PlayerPrefs.SetInt("High Level",currentLevel);
	}
	playerModel = GameObject.Find("zoop");
	activateWeapon(-1);//hide non default guns
	activateHat(-1);//hide non default hats
}

function Start(){
	armRun = playerModel.animation["armRun"];
	armRun.layer = 10;
	armRun.blendMode = AnimationBlendMode.Additive;
	armRun.enabled = true;
	
	canisterControl.randomizeColours();
}

//last Update code
function LateUpdate(){
	if (isDead){
		transform.position = Vector3(0,2,0); //move character when dead
		isDead=false;
		}
	if(gotHit){//on hit
		if (injurable) {
			audio.PlayOneShot(hurtSound);
			if (injureBuffer == 0){
				HealthControl.LIVES -=1;//take damage
				injurable = false;
				if (hat == 0 || hat == 4){
					injureBuffer = 1;
				}
			}
			else{
			 	injureBuffer--;
			 	injurable = false;
			}
		}
		injureCount();//count to hittable again
	}
	else if(gotHitBad){//major damage
		var exp = Instantiate(explosion, gameObject.transform.position, Quaternion.identity);//make explosion
		if (injurable) {
			audio.PlayOneShot(hurtSound);
			switch (injureBuffer){
			case 0:
				HealthControl.LIVES -=2;//take double damage
				injurable = false;
				if (hat == 0 || hat == 4){
					injureBuffer = 1;
				}
			break;
			case 1:
				injureBuffer--;
				injurable = false;
				HealthControl.LIVES -=1;
				if (hat == 0 || hat == 4){
					injureBuffer = 1;
				}
			break;
			default:
				injureBuffer-=2;
				injurable = false;
			}
		}
		injureCount();//count to hittable again
	}
}

//count for vulnerability
function injureCount(){
		if (injureCounter < 1){//if damage buffer reached
			gotHit = false; //hit no longer effective
			gotHitBad = false;
			injureCounter = backup[0]; //reset counter
			injureRecover = backup[1];
			injurable = true;//injurable again
		}
		else{//damage buffer not reached
			injureCounter -= injureRecover; //count down on buffer
			injureRecover += 0.6;//increase countdown rate
		}
}

//colliding with pickups
function OnTriggerStay(hit: Collider) {
    if (hit.gameObject.tag == "enemyProjectileRocket")//rocket damage
	{
		gotHitBad = true;
		Destroy(hit.gameObject);
	}else if (hit.gameObject.tag == "rocketPickup"){
		touchingGun = 2;
		weaponControl.ONROCKET = true;
		touchedGun = hit.gameObject;
	}else if (hit.gameObject.tag == "firePickup"){
		touchingGun = 1;
		weaponControl.ONFLAME = true;
		touchedGun = hit.gameObject; 
	}else if (hit.gameObject.tag == "bubblePickup"){
		touchingGun = 0;
		weaponControl.ONBUBBLER = true;
		touchedGun = hit.gameObject; 
	}else if (hit.gameObject.tag == "pewPickup"){
		touchingGun = 3;
		weaponControl.ONFLAME = true;
		touchedGun = hit.gameObject; 
	}else if (hit.gameObject.tag == "spreadPickup"){
		touchingGun = 4;
		weaponControl.ONBUBBLER = true;
		touchedGun = hit.gameObject; 
	}else if (hit.gameObject.tag == "rockPickup"){
		touchingGun = 5;
		weaponControl.ONFLAME = true;
		touchedGun = hit.gameObject; 
	}else if (hit.gameObject.tag == "waterPickup"){
		touchingGun = 6;
		weaponControl.ONBUBBLER = true;
		touchedGun = hit.gameObject; 
	}else if (hit.gameObject.tag == "disintPickup"){
		touchingGun = 7;
		weaponControl.ONFLAME = true;
		touchedGun = hit.gameObject; 
	}else if (hit.gameObject.tag == "vuvuPickup"){
		touchingGun = 8;
		weaponControl.ONFLAME = true;
		touchedGun = hit.gameObject; 
	}else if (hit.gameObject.tag == "spGunPickup"){
		touchingGun = 9;
		weaponControl.ONFLAME = true;
		touchedGun = hit.gameObject; 
	}else if (hit.gameObject.tag == "spCannonPickup"){
		touchingGun = 10;
		weaponControl.ONFLAME = true;
		touchedGun = hit.gameObject; 
	}/*****************
	*      HATS       /
	*****************/
	else if (hit.gameObject.tag == "footballPickup"){
		touchingHat = 0;
		touchedHat = hit.gameObject;
	}
	else if (hit.gameObject.tag == "cowboyPickup"){
		touchingHat = 1;
		touchedHat = hit.gameObject;
	}
	else if (hit.gameObject.tag == "pylonPickup"){
		touchingHat = 2;
		touchedHat = hit.gameObject;
	}
	else if (hit.gameObject.tag == "vikingPickup"){
		touchingHat = 3;
		touchedHat = hit.gameObject;
	}
	else if (hit.gameObject.tag == "popePickup"){
		touchingHat = 4;
		touchedHat = hit.gameObject;
	}
	else if (hit.gameObject.tag == "squidPickup"){
		touchingHat = 5;
		touchedHat = hit.gameObject;
	}
	else if (hit.gameObject.tag == "tophatPickup"){
		touchingHat = 6;
		touchedHat = hit.gameObject;
	}
	else if (hit.gameObject.tag == "slugPickup"){
		touchingHat = 7;
		touchedHat = hit.gameObject;
	}/*****************
	*      CANISTERS       /
	*****************/
	else if (hit.gameObject.tag == "capRedPickup"){
		touchingCap = 1;
		touchedCap = hit.gameObject;
	}
	else if (hit.gameObject.tag == "capGrnPickup"){
		touchingCap = 2;
		touchedCap = hit.gameObject;
	}
	else if (hit.gameObject.tag == "capBluPickup"){
		touchingCap = 3;
		touchedCap = hit.gameObject;
	}
	else if (hit.gameObject.tag == "capPrpPickup"){
		touchingCap = 4;
		touchedCap = hit.gameObject;
	}
	//print (touchingHat);
}

//colliding with instant pickups/bubbles
function OnTriggerEnter(hit: Collider)	{

	if (hit.gameObject.tag == "fallout"){//off of map
		isDead = true;
		HealthControl.LIVES =0;
	}
	else if (hit.gameObject.tag == "enemyProjectile")//basic damage
	{
		gotHit = true;
		var lH = Instantiate(laserHit, hit.gameObject.transform.position, Quaternion.identity);
		Destroy(hit.gameObject);
	}else if (hit.gameObject.tag == "enemyProjectileFire")//fire damage
	{
		gotHit = true;
		var fH = Instantiate(fireHit, gameObject.transform.position, Quaternion.identity);
		Destroy(hit.gameObject);
	}else if (hit.gameObject.tag == "chaser")//chaser damage
	{
		print("owwww");
		gotHitBad = true;
		hit.gameObject.transform.parent.GetComponent(enemyHealth).health=0;
	}else if (hit.gameObject.tag == "levelUp"){//increaseLevel
		currentLevel +=1;
		floorDisplay.CURRENTFLOOR = currentLevel;
		ScoreControl.currentScore += 100;
		if (PlayerPrefs.GetInt("High Level")<currentLevel){
			PlayerPrefs.SetInt("High Level",currentLevel);
	}
		Application.LoadLevel(currentLevel);
	}else if (hit.gameObject.tag == "aKey"){//get key to door
		keyControl.HASKEY = true;
		ScoreControl.currentScore += 30;
		audio.PlayOneShot(keySound);
		Destroy(hit.gameObject);
	}else if (hit.gameObject.tag == "aDoor"){//barrier door
		if (keyControl.HASKEY){
			print("unlocking");
			audio.PlayOneShot(doorSound);
			Destroy(hit.gameObject.transform.Find("VertDoor").gameObject); 
			hit.gameObject.transform.Find("lockedDoor").gameObject.animation.CrossFade("doorOpen");
			hit.gameObject.transform.Find("lockedDoor2").gameObject.animation.CrossFade("doorOpen"); 
			keyControl.HASKEY=false;
		}
		else print("touching");
	}else if (hit.gameObject.tag == "healBubble"){//health Bubble
		print("healin");
		if (HealthControl.LIVES <= 4){
			HealthControl.LIVES += 3;
		}
		else{
			HealthControl.LIVES = 7;
		}
	}else if (hit.gameObject.tag == "deathBubble")//rocket damage
	{
		gotHitBad = true;
	}
}	
	
//weapon swap
function gunPickup(){
		audio.PlayOneShot(switchSound);
	//print(touchingGun);
		GameObject.FindGameObjectWithTag("weaponHUD").GetComponent(weaponDisplay).cycleWeapon(touchingGun);//apply currently touched weapon for HUD
		var oldWeapon = weapon;//store currently held weaponID
		switch(weapon){//pick prefab to drop (current weapon)
			case 0: 
				gunDrop = bubbleGun;
			break;
			case 1: 
				gunDrop = flameGun;
			break;
			case 2: 
				gunDrop = rocketGun;
			break;
			case 3: 
				gunDrop = pewGun;
			break;
			case 4: 
				gunDrop = spreadGun;
			break;
			case 5: 
				gunDrop = rockGun;
			break;
			case 6: 
				gunDrop = waterGun;
			break;
			case 7: 
				gunDrop = disintGun;
			break;
			case 8: 
				gunDrop = vuvuGun;
			break;
			case 9: 
				gunDrop = spGun;
			break;
			case 10: 
				gunDrop = spcanGun;
			break;
		}
        weapon = touchingGun;//apply new weapon to player
        Destroy(touchedGun);//delete pickup
		if (oldWeapon > -1){
			newGun = Instantiate(gunDrop, gameObject.transform.position, Quaternion.identity);//generate new pickup
			newGun.transform.Translate(Vector3.up * -0.55, Space.World);//move pickup closer to floor
			}
		activateWeapon(oldWeapon);//fix rendering
}
	
//hat swap
function hatPickup(){
		audio.PlayOneShot(switchSound);
	//print(touchingHat);
		var oldHat = hat;//store currently held hatID
		switch(hat){//pick prefab to drop (current hatID)
			case 0: 
				hatDrop = footballPrefab;
			break;
			case 1: 
				hatDrop = cowboyPrefab;
			break;
			case 2: 
				hatDrop = pylonPrefab;
			break;
			case 3: 
				hatDrop = vikingPrefab;
			break;
			case 4: 
				hatDrop = popePrefab;
			break;
			case 5: 
				hatDrop = squidPrefab;
			break;
			case 6: 
				hatDrop = tophatPrefab;
			break;
			case 7: 
				hatDrop = slugPrefab;
			break;
		}
        hat = touchingHat;//apply new hat to player
        Destroy(touchedHat);//delete pickup
		if (oldHat > -1){
			newHat = Instantiate(hatDrop, gameObject.transform.position, Quaternion.identity);//generate new pickup
			newHat.transform.Translate(Vector3.up * -0.55, Space.World);//move pickup closer to floor
			}
		activateHat(oldHat);//fix rendering
}

//canister swap
function capPickup(){
		audio.PlayOneShot(switchSound);
	//print(touchingHat);
	GameObject.FindGameObjectWithTag("canisterHUD").GetComponent(canisterControl).cycleCapsule(touchingCap);
		var oldCap = cap;//store currently held capID
		switch(cap){//pick prefab to drop (current capID)
			case 1: 
				capDrop = capRedPrefab;
			break;
			case 2: 
				capDrop = capGrnPrefab;
			break;
			case 3: 
				capDrop = capBluPrefab;
			break;
			case 4: 
				capDrop = capPrpPrefab;
			break;
		}
        cap = touchingCap;//apply new hat to player
        Destroy(touchedCap);//delete pickup
		if (oldCap > 0){
			newCap = Instantiate(capDrop, gameObject.transform.position, Quaternion.identity);//generate new pickup
			newCap.transform.Translate(Vector3.up * -0.55, Space.World);//move pickup closer to floor
			}
			
}
	
//player weapon rendering
function activateWeapon(oldWeap){

	/*****************************
	* 0 = bubbler 		7 = disintigration 
	* 1 = flame			8 = vuvuzela
	* 2 = rockets
	* 3 = pew pew
	* 4 = spreader
	* 5 = rock
	* 6 = super soaker
	*/
	FlavTextTimer = Time.time + 5;
	var renderers; //init for renderers
	switch(oldWeap){//hide old weapon
		case -1://-1 is special case, init of map, hide all guns
			renderers = GameObject.FindGameObjectWithTag("rocketLauncher").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("bubbleGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("disintGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("rock").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("pewPew").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("spreadGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("waterGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("flameThrower").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
/*			renderers = GameObject.FindGameObjectWithTag("slingShot").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}*/
			renderers = GameObject.FindGameObjectWithTag("vuvu").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("spGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("spCannon").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
		break;
		case 0:
			renderers = GameObject.FindGameObjectWithTag("bubbleGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
		break;
		case 1:
			renderers = GameObject.FindGameObjectWithTag("flameThrower").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
   				r.enabled = false;
			}
		break;
		case 2:
			renderers = GameObject.FindGameObjectWithTag("rocketLauncher").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
		break;
		case 3:
			renderers = GameObject.FindGameObjectWithTag("pewPew").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
   				r.enabled = false;
			}
		break;
		case 4:
			renderers = GameObject.FindGameObjectWithTag("spreadGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
		break;
		case 5:
			renderers = GameObject.FindGameObjectWithTag("rock").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
   				r.enabled = false;
			}
		break;
		case 6:
			renderers = GameObject.FindGameObjectWithTag("waterGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
		break;
		case 7:
			renderers = GameObject.FindGameObjectWithTag("disintGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
   				r.enabled = false;
			}
		break;
		case 8:
			renderers = GameObject.FindGameObjectWithTag("vuvu").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
   				r.enabled = false;
			}
		break;
		case 9:
			renderers = GameObject.FindGameObjectWithTag("spGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
   				r.enabled = false;
			}
		break;
		case 10:
			renderers = GameObject.FindGameObjectWithTag("spCannon").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
   				r.enabled = false;
			}
		break;
	}
	switch(weapon){//show rendering of new weapon, adjust fire rate
		case 0:
			fireRate = 0.15;
			renderers = GameObject.FindGameObjectWithTag("bubbleGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			flavourTextHolder.weaponNum = 0;
		break;
		case 1:
			fireRate = 0.01;
			renderers = GameObject.FindGameObjectWithTag("flameThrower").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			flavourTextHolder.weaponNum = 1;
		break;
		case 2:
			fireRate = 1.5;
			renderers = GameObject.FindGameObjectWithTag("rocketLauncher").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			flavourTextHolder.weaponNum = 2;
		break;
		case 3:
			fireRate = .7;
			renderers = GameObject.FindGameObjectWithTag("pewPew").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			flavourTextHolder.weaponNum = 3;
		break;
		case 4:
			fireRate = .5;
			renderers = GameObject.FindGameObjectWithTag("spreadGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			flavourTextHolder.weaponNum = 4;
		break;
		case 5:
			fireRate = 0.01;
			renderers = GameObject.FindGameObjectWithTag("rock").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			flavourTextHolder.weaponNum = 5;
		break;
		case 6:
			fireRate = .01;
			renderers = GameObject.FindGameObjectWithTag("waterGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			flavourTextHolder.weaponNum = 6;
		break;
		case 7:
			fireRate = 2.5;
			renderers = GameObject.FindGameObjectWithTag("disintGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			flavourTextHolder.weaponNum = 7;
		break;
		case 8:
			fireRate = 0.01;
			renderers = GameObject.FindGameObjectWithTag("vuvu").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			flavourTextHolder.weaponNum = 8;
		break;
		case 9:
			fireRate = 0.1;
			renderers = GameObject.FindGameObjectWithTag("spGun").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			flavourTextHolder.weaponNum = 9;
		break;
		case 10:
			fireRate = .15;
			renderers = GameObject.FindGameObjectWithTag("spCannon").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			flavourTextHolder.weaponNum = 10;
		break;
	}
}	

//player hat rendering
function activateHat(oldHat){

	/*****************************
	* 0 = football 		 
	* 1 = cowboy		
	* 2 = pylon
	* 3 = viking
	* 4 = pope
	* 5 = squid
	* 6 = tophat
	* 7 = slug
	*/
	FlavText2Timer = Time.time + 5;
	var renderers; //init for renderers
	switch(oldHat){//hide old hat
		case -1://-1 is special case, init of map, hide all hats
			renderers = GameObject.FindGameObjectWithTag("football").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("cowboy").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("pylon").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("viking").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("pope").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("squid").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("tophat").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			renderers = GameObject.FindGameObjectWithTag("slug").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
		break;
		case 0:
			renderers = GameObject.FindGameObjectWithTag("football").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			speedMult = 1.0;
			injureBuffer = 0;
		break;
		case 1:
			renderers = GameObject.FindGameObjectWithTag("cowboy").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
   				r.enabled = false;
			}
			fireRateMult = 1.0;
		break;
		case 2:
			renderers = GameObject.FindGameObjectWithTag("pylon").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			speedMult = 1.0;
		break;
		case 3:
			renderers = GameObject.FindGameObjectWithTag("viking").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
   				r.enabled = false;
			}
			powerMult = 1.0;
			speedMult = 1.0;
		break;
		case 4:
			renderers = GameObject.FindGameObjectWithTag("pope").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			powerMult = 1.0;
			injureBuffer = 0;
		break;
		case 5:
			renderers = GameObject.FindGameObjectWithTag("squid").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
   				r.enabled = false;
			}
			powerMult = 1.0;
			cursor.CURSORON = true;
		break;
		case 6:
			renderers = GameObject.FindGameObjectWithTag("tophat").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = false;
			}
			speedMult = 1.0;
			fireRateMult = 1.0;
		break;
		case 7:
			renderers = GameObject.FindGameObjectWithTag("slug").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
   				r.enabled = false;
			}
			fireRateMult = 1.0;
			speedMult = 1.0;
		break;
	}
	switch(hat){//show rendering of new hat, adjust stats
		case 0:
			//fireRate = 0.15;
			renderers = GameObject.FindGameObjectWithTag("football").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			speedMult = 1.1;
			injureBuffer = 1;
			flavourTextHolder2.hatNum = 0;
		break;
		case 1:
			fireRateMult = 1.5;
			renderers = GameObject.FindGameObjectWithTag("cowboy").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			flavourTextHolder2.hatNum = 1;
		break;
		case 2:
			speedMult = 1.5;
			renderers = GameObject.FindGameObjectWithTag("pylon").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			flavourTextHolder2.hatNum = 2;
		break;
		case 3:
			powerMult = 1.8;
			speedMult = 0.7;
			renderers = GameObject.FindGameObjectWithTag("viking").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			flavourTextHolder2.hatNum = 3;
		break;
		case 4:
			renderers = GameObject.FindGameObjectWithTag("pope").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			powerMult = 0.7;
			injureBuffer = 1;
			flavourTextHolder2.hatNum = 4;
		break;
		case 5:
			renderers = GameObject.FindGameObjectWithTag("squid").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
   				r.enabled = true;
			}
			powerMult = 1.9;
			cursor.CURSORON = false;
			flavourTextHolder2.hatNum = 5;
		break;
		case 6:
			renderers = GameObject.FindGameObjectWithTag("tophat").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
    			r.enabled = true;
			}
			speedMult = 1.6;
			fireRateMult = 0.6;
			flavourTextHolder2.hatNum = 6;
		break;
		case 7:
			renderers = GameObject.FindGameObjectWithTag("slug").GetComponentsInChildren(Renderer);
			for (var r : Renderer in renderers) {
   				r.enabled = true;
			}
			fireRateMult = 2.0;
			speedMult = 0.55;
			flavourTextHolder2.hatNum = 7;
		break;
	}
}	

//player shooting
function doShooting(){
        nextFire = Time.time + fireRate/fireRateMult;//set next available fire time 
		switch(weapon){
			case 0://bubbler
				var bubble = Instantiate(bubblePrefab, transform.Find("BubbleGun").Find("spawnPoint").transform.position, transform.rotation);
				bubble.gameObject.tag = "playerProjectile";
				bubble.rigidbody.AddForce(transform.forward * 2000);
				var scaleAmt = Random.Range(-0.15, 0.15);//bubbles have a bit of random size
				bubble.transform.localScale+= Vector3(scaleAmt,scaleAmt,scaleAmt);
			break;
			case 1://flame
				var fire = Instantiate(firePrefab, transform.Find("Flamethrower").Find("spawnPoint").transform.position, Quaternion.identity);
				fire.gameObject.tag = "playerProjectileFire";
				fire.rigidbody.AddForce(transform.forward * 1000);
				fire.rigidbody.AddForce(transform.right * Random.Range(-300.0, 300.0));//spread of flame
			break;
			case 2://rockets
				var rocket = Instantiate(rocketPrefab, transform.Find("RocketLauncher").Find("spawnPoint").transform.position, transform.rotation);
				rocket.gameObject.tag = "playerProjectileRocket";
				rocket.rigidbody.AddForce(transform.forward * 500);
			break;
			case 3://pewPew
				var pew = Instantiate(pewPrefab, transform.Find("PewPew").Find("spawnPoint").transform.position, transform.rotation);
				pew.gameObject.tag = "playerProjectileLaser";
				pew.rigidbody.AddForce(transform.forward * 1500);
			break;
			case 4://spread
				var sp1 = Instantiate(spreadPrefab, transform.Find("Scattergun").Find("spawnPoint").transform.position, transform.rotation);
				sp1.gameObject.tag = "playerProjectileLaser";
				sp1.rigidbody.AddForce(transform.forward * 1500);
				var sp2 = Instantiate(spreadPrefab, transform.Find("Scattergun").Find("spawnPoint").transform.position, transform.rotation);
				sp2.gameObject.tag = "playerProjectileLaser";
				sp2.rigidbody.AddForce(transform.forward * 1500);
				sp2.rigidbody.AddForce(transform.right * 500);
				var sp3 = Instantiate(spreadPrefab, transform.Find("Scattergun").Find("spawnPoint").transform.position, transform.rotation);
				sp3.gameObject.tag = "playerProjectileLaser";
				sp3.rigidbody.AddForce(transform.forward * 1500);
				sp3.rigidbody.AddForce(transform.right * -500);
			break;
			case 5:  
				if (rockMultiplier < 2.8){
				rockMultiplier +=.01;
				print(rockMultiplier);}
			break;
			case 6://watergun
				var water = Instantiate(waterPrefab, transform.Find("SuperSoaker").Find("spawnPoint").transform.position, transform.rotation);
				water.gameObject.tag = "playerProjectileWater";
				water.rigidbody.AddForce(transform.forward * 1000);
			break;
			case 7://disint
				var disint = Instantiate(disintPrefab, transform.Find("Disintergrator").Find("spawnPoint").transform.position, transform.rotation);
				disint.gameObject.tag = "playerProjectileDisint";
				disint.rigidbody.AddForce(transform.forward * 400);
			break;
			case 8://vuvuz
				var vuFire = Instantiate(vuvuPrefab, transform.Find("Vevuzela").Find("spawnPoint").transform.position, transform.rotation);
				vuFire.gameObject.tag = "playerProjectileVuvu";
				vuFire.rigidbody.AddForce(transform.forward * 1000);
				vuFire.rigidbody.AddForce(transform.right * Random.Range(-300.0, 300.0));//spread of flame
			break;
			case 9://spGun
				var spg1 = Instantiate(spgPrefab, transform.Find("SpaceGun").Find("spawnPoint").transform.position, transform.rotation);
				spg1.gameObject.tag = "playerProjectileSpg";
				spg1.rigidbody.AddForce(transform.forward * 1500);
			break;
			case 10://spCannon
				var spc1 = Instantiate(spcPrefab, transform.Find("SpaceCannon").Find("spawnPoint").transform.position, transform.rotation);
				spc1.gameObject.tag = "playerProjectileSpc";
				spc1.rigidbody.AddForce(transform.forward * 400);
				spc1.rigidbody.AddForce(transform.right * Random.Range(-200.0, 200.0));
			break;
		}
}

function throwCharged(){
	switch(weapon){
		case 5:
			var rock = Instantiate(rockPrefab,transform.Find("LemonRock").transform.position, transform.rotation);
			rock.gameObject.tag = "playerProjectileRock";
			var position = Input.mousePosition;//get mouse
			newposition = Vector3(position.x, position.y, camera.main.transform.position.y- transform.position.y);//transform mouse with y
			var lastposition2 = camera.main.ScreenToWorldPoint(newposition);
			rock.transform.LookAt(lastposition2);//rotate rock to cursor
			rock.transform.eulerAngles.z = originalZ;//reset z/x rotation if any happened
			rock.transform.eulerAngles.x = originalX;
			rock.rigidbody.AddForce(rock.transform.forward * 200 * rockMultiplier);
			//rockMultiplier = 1;
			weapon = -1;
			activateWeapon(-1);
		break;
	}
}

function throwCapsule(){
	var throwCap = Instantiate(capThrow, transform.Find("gun").Find("spawnPoint").transform.position, transform.rotation);
	throwCap.GetComponent(canisterCollide).assignNum(cap);
	throwCap.rigidbody.AddForce(transform.forward * 1000);
	canisterControl.cycleCapsule(0);
	cap = 0;
}

function openCapsule(){
	var isAHealth = false;
	switch(cap){
		case 1:
			isAHealth = canisterControl.redHealth;
		break;
		case 2:
			isAHealth = canisterControl.grnHealth;
		break;
		case 3:
			isAHealth = canisterControl.bluHealth;
		break;
		case 4:
			isAHealth = canisterControl.prpHealth;
		break;
	}
	if (isAHealth){
		var healBubble = Instantiate(healBubPF, transform.Find("gun").Find("spawnPoint").transform.position, transform.rotation);
	}
	else{
		var deathBubble = Instantiate(deathBubPF, transform.Find("gun").Find("spawnPoint").transform.position, transform.rotation);
	}
	canisterControl.cycleCapsule(0);
	cap = 0;	
}

//main
function Update(){
	var controller : CharacterController = GetComponent(CharacterController);//get character control

	moveDirection = Vector3(Input.GetAxis("Horizontal"), 0, Input.GetAxis("Vertical"));//moving wasd
    moveDirection *= speed*speedMult;
    controller.Move(moveDirection * Time.deltaTime);
    controller.SimpleMove(Vector3(0,0,0));//for gravity+collision
        
	var position = Input.mousePosition;//get mouse
	newposition = Vector3(position.x, position.y, camera.main.transform.position.y- transform.position.y);//transform mouse with y
	var lastposition2 = camera.main.ScreenToWorldPoint(newposition);
	transform.LookAt(lastposition2);//rotate character to cursor
	
	transform.eulerAngles.z = originalZ;//reset z/x rotation if any happened
	transform.eulerAngles.x = originalX;
	
   if (Input.GetAxis("Vertical") > 0.2 || Input.GetAxis("Vertical") < -0.2 || Input.GetAxis("Horizontal") > 0.2 || Input.GetAxis("Horizontal") < -0.2){
     //	print("movin");
      	playerModel.animation.CrossFade ("zoopWalk");
      	armRun.enabled = true;
      	playerModel.animation.CrossFade("armRun");
     }
   else{
      	armRun.enabled = false;
     	playerModel.animation.CrossFade ("idle");
  //   	print("not movin");
     }
      
	if (Time.time > FlavTextTimer){
		flavourTextHolder.weaponNum = -1;
	}
	if (Time.time > FlavText2Timer){
		flavourTextHolder2.hatNum = -1;
	}
	if (weapon == 8 && Time.time > nextFire){
		doShooting();
	}
	else {
		if (Input.GetMouseButton(0) && Time.time > nextFire)//if click is down and fire rate time has been met
		{
			doShooting();
		}
		if (Input.GetMouseButtonUp(0) && Time.time > nextFire)//if click is up and fire rate time has been met
		{
			throwCharged();
		}
	}
	if (Input.GetMouseButton(1) && cap > 0)//if right click and has capsule
	{
		throwCapsule();
	}
	if (Input.GetKeyDown(KeyCode.E) && cap > 0)
	{
		openCapsule();
	}
	if ((Input.GetKeyDown(KeyCode.LeftShift) || Input.GetKeyDown(KeyCode.Space)) && touchingGun >= 0){//if in contact with gun pickup and switch weapon has been hit
        gunPickup();
	}
	if ((Input.GetKeyDown(KeyCode.LeftShift) || Input.GetKeyDown(KeyCode.Space)) && touchingHat >= 0){//if in contact with hat pickup and switch weapon has been hit
        hatPickup();
	}
	if ((Input.GetKeyDown(KeyCode.LeftShift) || Input.GetKeyDown(KeyCode.Space)) && touchingCap >= 0){//if in contact with canister pickup and switch weapon has been hit
        capPickup();
	}
	
	touchingGun = -1;//reset pickup touch
	touchedGun = null;
	
	touchingHat = -1;//reset pickup touch
	touchedHat = null;
	
	touchingCap = -1;//reset pickup touch
	touchedCap = null;
}

@script RequireComponent(CharacterController)